package main

import (
	"encoding/json"
	"fmt"
)

type Bar struct {
	Name string `json:"name"`
}

func main() {
	// 构造
	bs := []byte{78, 79, 241}
	fmt.Println(bs)
	fmt.Println(string(bs))

	// struct 非 unicode 转化实例
	name1 := []byte{0x80, 0x61, 0x62, 0x63}
	bar1 := &Bar{
		Name: string(name1),
	}

	bar1bs, err := json.Marshal(bar1)
	if err != nil {
		panic(err)
	}

	var bar2 Bar
	err = json.Unmarshal(bar1bs, &bar2)
	if err != nil {
		panic(err)
	}

	bar2bs, err := json.Marshal(bar2)
	if err != nil {
		panic(err)
	}

	fmt.Printf("bar1 name: %s, bs: %#v\n", bar1.Name, bar1bs)
	fmt.Printf("bar2 name: %s, bs: %#v\n", bar2.Name, bar2bs)
}
